/******************************************************************
 *  Décharge d'un condensateur pilotée par une sortie numérique   *
*******************************************************************/

// Declaration des variables 
unsigned long temps,t0;         // acquisition du temps en milliseconde            
float t ;                       // calcul du temps écooulé réel
int E =0, Uc =0 ;  // définition et mise à zéro des tensions mesurées sur des entrées analogiques et quantifiées entre 0 et 1023
float  tensionE, tensionUc;     //  définition des tensions converties en valeur analogique
const int pin_E = 0 ; // définition de l'entrée analogique pin_E sur le port A0  
const int pin_Uc = 5;  // défintion de l'entrée analogique pin_Uc sur le port A5  
// Définition de la broche de sortie numérique jouant le rôle de générateur
int pin_gene = 13;

/* Initialisation et prise de mesure unique
 pour relancer la mesure, appuyer sur la touche reset du microcontrôleur après 
avoir effacé les données précédentes sur le moniteur*/
 
void setup()
{
  pinMode(pin_gene, OUTPUT);   
  Serial.begin(9600);    // communication avec le port série Moniteur avec un débit à 9600 bauds
  // dans un premier temps, on s'assure que le condensateur est completement chargé
  digitalWrite(pin_gene, HIGH); 
  Serial.print("Veuillez patienter 10 secondes. Quand la LED s'éteindra, la mesure démarrera\n");
  delay(10000); //Pose de 10 secondes pour etre sûr de charger le condensateur
  //la LED sur le port 13 reste allumée 10s en vérification
  // definition des en-têtes des colonnes contenant les mesures , avec les unités, pour traitement sur tableur 
  Serial.print("t\t");//affiche le caractère t suivi d'une tabulation
  Serial.print("Uc\t");
  Serial.print("E\n");// remplace l'instruction Serial.println("E) 
  Serial.print("s\t");
  Serial.print("V\t");
  Serial.print("V\n");
  //  décharge du condensateur : passage à 0V
  digitalWrite(pin_gene, LOW); //   sortie logique pin_gene sur 0V
  t0=millis();
  { // décharge du condensateur
    Uc = analogRead(pin_Uc);  // mesure la tension aux bornes de C
    while (Uc > 3) // attention tension entre 0 et 1023
    { // pas completement déchargé mais presque
      temps = millis();
      Uc = analogRead(pin_Uc);   
      E = analogRead(pin_E);   
      t = (temps-t0)/1000.0;  
      tensionE = 5 * E / 1023.0;
      tensionUc = 5 * Uc / 1023.0;
      // Envoie et affiche les mesures sur le port série
      Serial.print(t,3);         // Envoie la valeur de t  en s
      Serial.print("\t");        // tabulation              
      Serial.print(tensionUc );   // Envoie la mesure de Uc en V sur le port série  
      Serial.print("\t");        
      Serial.println(tensionE);    // Envoie la mesure de E en V sur le port série  
    }
  }
}
// Boucle principale vide:
void loop()
{}
