/******************************************************************
    Charge d'un condensateur pilotée par une sortie numérique
******************************************************************/
// Déclaration des variables
unsigned long temps, t0;        // acquisition du temps en milliseconde
float t ;                       // calcul du temps écoulé réel
int E = 0, Uc = 0 ;             // définition et mise à zéro des tensions mesurées sur des entrées analogiques
float  tensionE, tensionUc;     // définition des tensions converties en valeur analogique
const int pin_E = 0 ;           // définition de l'entrée analogique pin_E (A0)
const int pin_Uc= 5;            // définition de l'entrée analogique pin_Uc (A5)

// Définition de la broche de sortie numérique jouant le rôle de générateur
int pin_gene = 13;
/* Initialisation et prise de mesure unique
  Pour relancer la mesure, appuyer sur la touche reset du microcontrôleur après
  avoir effacé les données précédentes sur le moniteur */
void setup()
{
  pinMode(pin_gene, OUTPUT);   
  Serial.begin(9600);         // communication avec le port série Moniteur avec un débit à 9600 bauds
// dans un premier temps, on s'assure que le condensateur est complètement déchargé :
  digitalWrite(pin_gene, LOW);  
  Serial.println("Veuillez patienter 10 secondes, le temps de décharger complètement le condensateur");
  delay(10000);          //Pose de 10 secondes pour être sûr de décharger le condensateur
// définition des en-têtes des colonnes contenant les mesures, avec les unités, pour traitement sur tableur
  Serial.print("t");
  Serial.print("\t");// création d'une tabulation
  Serial.print("E\t");// autre méthode pour avoir une tabulation après affichage de E
  Serial.println("Uc"); // affichage de Uc et changement de ligne
  Serial.print("s\t"); //affichage de l'unité de temps en s  
  Serial.print("V\t"); //affichage de l'unité de tension en V
  Serial.print("V\n");// affichage de l'unité de tension en V et changement de ligne
// initialiation
  digitalWrite(pin_gene, HIGH);  
  t0 = millis();           // définition de l'intant initial
  E = analogRead(pin_E);   
/*** prise des mesures : charge du condensateur ***/
  Uc = analogRead(pin_Uc);  
/* définition du seuil au-delà duquel la prise de mesures stoppe.
La valeur de E n'étant pas forcément atteinte du fait de la précsion des mesures
et pour éviter de prolonger la mesure*/
  int seuil = E * 0.99; 
  while (Uc < seuil)  
  {//charge du condensateur
    temps = millis();
    Uc = analogRead(pin_Uc);   
    E = analogRead(pin_E);   
    t = (temps - t0) / 1000.0;  
    tensionE = 5 * E / 1023.0;
    tensionUc = 5 * Uc / 1023.0;
    // affichage  des mesures sur le port série
    Serial.print(t, 3);        // affiche  la valeur de t avec 3 décimales
    Serial.print("\t");        // tabulation
    Serial.print(tensionE);    // affiche la valeur de E avec 2 décimales (valeur par défaut)
    Serial.print("\t");         // tabulation
    Serial.println(tensionUc ); // affiche la valeur de Uc  passe à la ligne suivante
  }
  digitalWrite(pin_gene, LOW); // remettre à zéro la sortie pin_gene en attendant un nouvel ordre de mesure
}
// Boucle principale vide :
void loop()
{}
