""" Etude de la décharge  du circuit RC à partir d'un fichier .txt """

#import matplotlib.pyplot as plt
from matplotlib.widgets import Cursor
from pylab import *#inclut numpy et matplotlib
#import numpy as np
import math
import os # os: operating system: module permettant de dialoguer avec le système d'exploitation

R = float(input("Entrer la valeur de R (en ohm) :   "))
C = float(input("Entrer la valeur de C (en farad) :    "))
nomFichier = str(input('Nom du fichier à lire '))
fichier_de_mesures = nomFichier+ '.txt'
repertoire=str(input('Nom du repertoire de travail:  '))
os.chdir(repertoire)

 
# Lecture du fichier
def lecture(fichier):
    f = open(fichier)
    lignes = f.readlines()
    lignes = lignes[2:]# vérifier le numéro de la ligne contenant les premières mesures
    temps,E,Uc = [],[],[]
    for line in lignes:
        t,uc,e = line.split('\t')
        temps.append(float(t))
        E.append(float(e))
        Uc.append(float(uc))
    f.close()
    return temps,E,Uc
    
# On attribue les noms aux 3 listes contenues dans le fichier
t1,u0,u1=(lecture(fichier_de_mesures))
 
# détermination de tau expérimental
def modele(t1,u):
   umax = max(u)
   for i in range(len(t1)-1):
       if u[i]>=umax*0.37 and u[i+1]<=umax*0.37:
            tauexp=(t1[i]+t1[i+1])/2
            return umax,tauexp

Umax,tauexp=modele(t1,u1)
print("Umax  :\t",Umax," V")
print("tau experimental :\t",round(tauexp,2), "s") 

# calcul de tau theorique 
def calculTau(R,C):
    tau =R*C
    return tau
tau=calculTau(R,C)
print("tau theorique :\t ",round(tau,2)," s")

# Modele 
def ucm(t):
    return Umax*(np.exp(-t/tauexp))
Ucm=[]
for i in range(len(t1)):
    Ucm.append(ucm(t1[i]))
    
# Calcul de ur
Ur=[]
for i in range(len(t1)):
    Ur.append(-ucm(t1[i]))
    
# ***************************************************************************
# Tracé des graphes: voir https://courspython.com/introduction-courbes.html
# ***************************************************************************
# Les 3 graphes
fig1 = subplot(221) 
plot(t1,u0,"b*",label='e(t)')
plot(t1,u1,"r+",label='uc(t)')
xlabel("t (s)")
ylabel("tension (V)")
axis([0,t1[-1],0,5.5])
title('uc(t) et e(t)')
legend(loc='best')
grid()
cursor1 = Cursor(fig1, useblit=True, color='blue', linewidth=1)
# Tracé temporel du signal et modelisation
fig2 = subplot(222)
plot(t1,u1,"r+",label='uc(t)')
plot(t1,Ucm,'b',label='ucm(t)')
xlabel("t (s)")
ylabel("tension (V)")
axis([0,t1[-1],0,5.5])
title('uc(t) et son modele')
legend(loc='best')
grid()
cursor2 = Cursor(fig2, useblit=True, color='green', linewidth=1)
# Tracé temporel du signal et de ur(t)
fig3 = subplot(223)
plot(t1,u1,"r+",label='uc(t)')
plot(t1,Ur,'b',label='ur(t)')
xlabel("t (s)")
ylabel("tension (V)")
legend(loc='best')
title('uc(t) et ur(t)')
grid()
cursor3 = Cursor(fig3, useblit=True, color='black', linewidth=1)
show()
image = nomFichier
savefig(nomFichier)
 # sauvegarde les graphes dans le fichier image au format png dans 
#le répertoire défini par l'opérateur avec un nom identique au nom du fichier de mesures

